/* server v1.1 */


call RxFuncAdd "SysSleep","REXXUTIL","SysSleep"
call RxFuncAdd 'mciRxInit','MCIAPI','mciRxInit' 
call mciRxInit
call mciRxSendString 'open cdaudio01 alias cdaud01 shareable wait', 'RetStr', '0', '0'

signal on halt

rc = RxQueue(create, c_d_s_e_r_v_e_r)
rc = RxQueue(Set,  c_d_s_e_r_v_e_r)


Do forever

call mciRxSendString 'status cdaud01 media present wait', 'RetStr', '0', '0'
call mciRxSendString 'status cdaud01 number of tracks wait', 'tot_trks', '0', '0'

	If queued() > 0 then do

	
		text = linein('QUEUE:')
				if translate(text) = 'EXIT' then signal halt



If RetStr >< False then do
				if translate(text) = 'PLAY' then do
					call mciRxSendString 'Status cdaud01 mode wait', 'playermode', '0', '0'

					Select 
					When playermode="stopped" then 
				  call mciRxSendString 'play cdaud01', 'RetStr', '0', '0'
	
					When playermode="paused"  then call mciRxSendString 'resume cdaud01', 'RetStr', '0', '0'
	
					Otherwise NOP
				  End
				END	


				if translate(text) = 'SKIP' then do

					call mciRxSendString 'Status cdaud01 mode wait', 'playermode', '0', '0'
					call mciRxSendString 'status cdaud01 number of tracks wait', 'tot_trks', '0', '0'


					If playermode="playing" | playermode="paused" | playermode="stopped" then do
						call mciRxSendString 'status cdaud01 current track wait', 'Tracknummer', '0', '0'
						If Tracknummer < tot_trks then Tracknummer = Tracknummer + 1
						else NOP

					end

					Call mciRxSendString 'status cdaud01 position track' Tracknummer 'wait', 'NewPos', '0', '0'

					Select 
						When playermode="stopped" then call mciRxSendString 'seek cdaud01 to' NewPos 'wait', 'RetStr', '0', '0'
						When playermode="playing" | playermode="paused" then call mciRxSendString 'play cdaud01 from' NewPos, 'RetStr', '0', '0'
						Otherwise NOP
					End

				end

				if translate(text) = 'BACK' then do

					call mciRxSendString 'Status cdaud01 mode wait', 'playermode', '0', '0'
					call mciRxSendString 'status cdaud01 number of tracks wait', 'tot_trks', '0', '0'

					If playermode="playing" | playermode="paused" | playermode="stopped" then do
						call mciRxSendString 'status cdaud01 current track wait', 'Tracknummer', '0', '0'
						If Tracknummer > 1 then do
									call mciRxSendString 'status cdaud01 position in Track wait', 'Track_Zeit', '0', '0'
									ts = Track_Zeit / 3000
				
									If ts < 3 then Tracknummer = Tracknummer - 1  /* 2 = seconds */
									else NOP
									end

								else NOP

					end

					Call mciRxSendString 'status cdaud01 position track' Tracknummer 'wait', 'NewPos', '0', '0'


					Select 
						When playermode="stopped" then call mciRxSendString 'seek cdaud01 to' NewPos 'wait', 'RetStr', '0', '0'
						When playermode="playing" | playermode="paused" then call mciRxSendString 'play cdaud01 from' NewPos, 'RetStr', '0', '0'
						Otherwise NOP
					End
	end


				if translate(text) = 'STOP' then
				do
					call mciRxSendString 'Status cdaud01 mode wait', 'playermode', '0', '0'

					If playermode="playing" | playermode= "paused" |  playermode = "stopped" then 
					do
						call mciRxSendString 'seek cdaud01 to start wait', 'RetStr', '0', '0'
						call mciRxSendString 'stop cdaud01', 'RetStr', '0', '0'
					end
					else NOP
end
	
			if translate(text) = 'PAUSE' then call mciRxSendString 'pause cdaud01', 'RetStr', '0', '0'

	
  end		/*if queued	*/	
				
end /*retstr*/

rc = SysSleep(1)
end /*forever*/




ENDE:
call mciRxExit
call RxFuncDrop "SysSleep"
rc = RxQueue(delete,   c_d_s_e_r_v_e_r)
Exit

HALT:
rc = mciRxSendString('close cdaudio01 wait', 'RetStr', '0', '0')
call mciRxExit
call RxFuncDrop "SysSleep"
rc = RxQueue(delete,   c_d_s_e_r_v_e_r)
exit
